//  Shader_3D_UBER.fsh

precision highp float;


#define PIE	(3.141592653)
#define TWOPIE	(PIE*2.0)



#ifndef PROGRAMTYPE_BUILD

// these will be defined in the header to the new variant shader

#define DIFFUSEMAPENABLE					
#define SHADOWMAPENABLE					
#define USESPECULAR					
#define USEREFLECTION					
#define USEEMISSIVE					
#define USEEMISSIVEMAP				
#define USENORMALMAP					
#define USESPECULARINTENSITYMAP		
#define USEREFLECTIONINTENSITYMAP		
#define USEPHONG
#define USEBLENDDIFFMAPS							
#define USEDIFFUSEMAP2				
#define USEDIFFUSELIGHTING				

#define lightMaterial_uDiffuseUVSet						0
#define lightMaterial_uDiffuse2UVSet					3
#define lightMaterial_uReflectionIntensityUVSet			0
#define lightMaterial_uShadowUVSet						1
#define lightMaterial_uSpecularIntensityUVSet			0
#define lightMaterial_uNormalUVSet						0
#define lightMaterial_uEmissiveUVSet					2

#define lightMaterial_uDiffuseAlphaUVSet				0

#define VSUSENORMAL
#define VSUSETANGENTS
#define VSUSEVCOLOUR
#define VSUSETEX1
#define VSUSETEX2
#define VSUSETEX3
#define VSUSETEX4

#endif		//PROGRAMTYPE_BUILD

#ifdef USEDIFFUSELIGHTING
#define LIGHTINGORREFLEC
#endif
#ifdef USEREFLECTION
#ifndef LIGHTINGORREFLEC
#define LIGHTINGORREFLEC
#endif
#endif
#ifdef USESPECULAR
#ifndef LIGHTINGORREFLEC
#define LIGHTINGORREFLEC
#endif
#endif

#ifdef USEPHONG
#define PASSPOSITIONTHRO
#endif

#ifndef WORLDPOSITION
#ifdef USEOVERLAY0
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY1
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY2
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY3
#define WORLDPOSITION
#endif
#endif


#ifndef WORLDPOSITION
#ifdef USESPECIAL_OCEAN
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_BEACH
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_SHALLOW
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_GLASS
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_AURORA
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESNOW
#define WORLDPOSITION
#endif
#endif

#ifndef WORLDPOSITION
#ifdef USEGRASSSHADER
#define WORLDPOSITION
#endif
#endif

#ifndef WORLDPOSITION
#ifdef USEGREENFRESNEL
#define WORLDPOSITION
#endif
#endif

// No input data here, this is the fragment shader

// This is the vertex OUTPUT data which gets interpolated and fed into pixel shader per scanned screen pixel

#ifdef VSUSEPOSITION
varying highp vec4 v_position;
#endif
#ifdef VSUSEPOSITIONSMAP
varying highp vec4 v_position_lig;
#endif
#ifdef VSUSECOLOUR
varying highp vec4 v_vertcol;
#endif

#ifdef USEPHONG
varying highp vec3 v_normal;
#endif
#ifdef USEGREENFRESNEL
varying highp vec3 v_normalrot;
#endif
#ifdef PASSPOSITIONTHRO
varying highp vec4 v_positionthro;
#endif
#ifdef WORLDPOSITION
varying highp vec4 v_worldposition;
#endif

#ifdef NEWOVERLAY
#ifdef USEOVERLAY0
varying highp vec2 v_overlay0;
#endif
#ifdef USEOVERLAY1
varying highp vec2 v_overlay1;
#endif
#ifdef USEOVERLAY2
varying highp vec2 v_overlay2;
#endif
#ifdef USEOVERLAY3
varying highp vec2 v_overlay3;
#endif
#endif

#ifdef VSUSETANGENTS
varying highp vec3 v_tangent;
varying highp vec3 v_binormal;
#endif

#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifdef VSUSETEX3
#ifdef VSUSETEX4
varying highp vec2 v_texCoords[4];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifdef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[3];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifndef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[2];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifndef VSUSETEX2
#ifndef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[1];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSEVCOLOUR
varying highp vec4 v_blend;
#endif

#ifndef USEPHONG
#ifdef USEREFLECTION	
varying highp vec3 v_reflecVec;
#endif
#ifdef USESPECULAR
varying highp vec3 v_colourSpec;
#endif
#ifdef USEDIFFUSELIGHTING
varying highp vec3 v_colour;
#endif
#endif



#define LIGHTMATERIAL_DIFFUSE		0
#define LIGHTMATERIAL_AMBIENT		1
#define LIGHTMATERIAL_SPECULAR		2
#define LIGHTMATERIAL_EMISSIVE		3
#define LIGHTMATERIAL_SPECULARPOWER	4
#define LIGHTMATERIAL_REFLECMULT	4
#define LIGHTMATERIAL_SHADOWMULT	4
#define LIGHTMATERIAL_NORMALHEIGHT	4
#define LIGHTMATERIAL_MULCOL		5

#define LIGHTMATERIAL_TOTALSIZE     6		// was 5 but we added mulcol

#define lightMaterial_diffuse			LightMaterial[LIGHTMATERIAL_DIFFUSE]
#define lightMaterial_ambient			LightMaterial[LIGHTMATERIAL_AMBIENT]
#define lightMaterial_specular			LightMaterial[LIGHTMATERIAL_SPECULAR]
#define lightMaterial_emissive			LightMaterial[LIGHTMATERIAL_EMISSIVE]
#define lightMaterial_specularpower		LightMaterial[LIGHTMATERIAL_SPECULARPOWER][0]
#define lightMaterial_reflecMult		LightMaterial[LIGHTMATERIAL_REFLECMULT][1]
#define lightMaterial_shadowMult		LightMaterial[LIGHTMATERIAL_SHADOWMULT][2]
#define lightMaterial_normalHeight		LightMaterial[LIGHTMATERIAL_NORMALHEIGHT][3]
#define lightMaterial_mulcol			LightMaterial[LIGHTMATERIAL_MULCOL]



uniform vec4 LightMaterial[LIGHTMATERIAL_TOTALSIZE];


#define shadData_colour(_n)		ShaderEffs[2*_n + 0]
#define shadData_sat(_n)		ShaderEffs[2*_n + 1][0]
#define shadData_hue(_n)		ShaderEffs[2*_n + 1][1]
#define shadData_lig(_n)		ShaderEffs[2*_n + 1][2]
#define shadData_test(_n)		ShaderEffs[2*_n + 1][3]

uniform vec4 ShaderEffs[2*8];


#define LIGHTS_AMBIENT		0
#define LIGHTS_SIZE			1

#define LIGHT_DIFFUSE		0
#define LIGHT_SPECULAR		1
#define LIGHT_POSITION		2
#define LIGHT_DIRECTION		3
#define LIGHT_RANGE			4
#define LIGHT_ATTENUATION0	4
#define LIGHT_ATTENUATION1	4
#define LIGHT_ATTENUATION2	4
#define LIGHT_SIZE			5

#define LIGHTS_TOTALSIZE (LIGHTS_SIZE+NUMLIGHTSTOUSE*LIGHT_SIZE)

//#define lights_numLights		Lights[LIGHTS_NUMLIGHTS][0]
#define lights_ambient			Lights[LIGHTS_AMBIENT]

#define light_diffuse(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_DIFFUSE]
#define light_specular(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_SPECULAR]
#define light_position(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_POSITION]
#define light_direction(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_DIRECTION]
#define light_range(_n)			Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_RANGE][0]
#define light_attenuation0(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION0][1]
#define light_attenuation1(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION1][2]
#define light_attenuation2(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION2][3]

uniform vec4 Lights[LIGHTS_TOTALSIZE];

//#define SHADER_LIGHT_DIRECTIONAL	0.0
//#define SHADER_LIGHT_POINT			1.0

uniform highp vec4 MulCol;
uniform highp vec4 RangeCol;
//uniform highp vec4 RangeData;
uniform highp vec4 Highlight;


// constants
uniform float	c_fTime;	
uniform float	AlphaRef;
		
uniform float	c_windMult;
uniform float	c_ShakeMult;
uniform float	c_windX;
uniform float	c_windY;

uniform	float	reflecRotSin;
uniform float	reflecRotCos;

uniform float	c_uvDeltaU1;
uniform float	c_uvDeltaV1;
uniform float	c_uvDeltaU2;
uniform float	c_uvDeltaV2;
uniform float	c_uvMultiply;
uniform float	c_uvDeltaDiffuseU;
uniform float	c_uvDeltaDiffuseV;

//uniform vec4	c_uvPosition[4];			//NOTE THis is per UV set, not per texture
uniform vec4	c_depthColour;

uniform	float c_SnowMask1Scaling;			//only if useSnow
uniform	float c_SnowMask2Scaling;
uniform	float c_RefMaskScaling;
uniform	float c_SnowTexScaling;

uniform float	c_ClipBallX;
uniform float	c_ClipBallY;
uniform float	c_ClipBallZ;
uniform float	c_ClipBallAng;

uniform float	c_waveFrequency;
uniform float	c_waveSpeed;
uniform float	c_waveIntensity;

uniform float	c_ovSize0;					
uniform float	c_ovSize1;					
uniform float	c_ovSize2;					
uniform float	c_ovSize3;					

uniform float	c_ovPosX0;					
uniform float	c_ovPosX1;					
uniform float	c_ovPosX2;					
uniform float	c_ovPosX3;					

uniform float	c_ovPosY0;					
uniform float	c_ovPosY1;					
uniform float	c_ovPosY2;					
uniform float	c_ovPosY3;					

uniform float	c_ovAlpha0;					
uniform float	c_ovAlpha1;					
uniform float	c_ovAlpha2;					
uniform float	c_ovAlpha3;					

uniform float	c_ovSat0;					
uniform float	c_ovSat1;					
uniform float	c_ovSat2;					
uniform float	c_ovSat3;					

uniform float	c_ovLig0;
uniform float	c_ovLig1;
uniform float	c_ovLig2;
uniform float	c_ovLig3;

uniform float	c_uThickness;
uniform float	c_uMaterialFresnel;
uniform float	c_uReflectionFresnel;
uniform float	c_uUFrames;

uniform float	c_ScrollSpeed;
uniform float	c_FresnelPower;
uniform float	c_FresnelBias;
uniform float	c_uUFrameTime;

uniform float	c_uGreenFresnelBias;
uniform float	c_uGreenFresnelPower;
uniform float	c_uGreenFresnelRed;
uniform float	c_uGreenFresnelGreen;
uniform float	c_uGreenFresnelBlue;

uniform float	c_uSurfaceType;

//Mirror gShader values
uniform mat4 modelViewProjectionMatrix;			//not used in pshader
uniform mat4 modelViewProjShadowMatrix;			//not used in pshader
uniform mat4 viewNormalizedInvMatrix;			//pos IS used in pshader
uniform mat4 modelMatrix;						//mat IS used in pshader
uniform mat4 viewProjectionMatrix;				//not used in pshader

uniform vec4 camPos;
uniform vec4 camZDir;

uniform sampler2D s_texture1;
uniform sampler2D s_texture2;
uniform sampler2D s_texture3;
uniform sampler2D s_texture4;
uniform sampler2D s_texture5;
uniform sampler2D s_texture6;
uniform sampler2D s_texture7;
uniform samplerCube s_texture8;


//----------------------------------------------------------------------------------

// compatibility functions

vec4 lerp(vec4 a, vec4 b, float f)
{
	return vec4(a.x+(b.x-a.x)*f,a.y+(b.y-a.y)*f,a.z+(b.z-a.z)*f,a.w+(b.w-a.w)*f);
}
vec3 lerp(vec3 a, vec3 b, float f)
{
	return vec3(a.x+(b.x-a.x)*f,a.y+(b.y-a.y)*f,a.z+(b.z-a.z)*f);
}

float lerpfloat(float a, float b, float f)
{
	return a+(b-a)*f;
}

float frac(float x)
{
	return x-floor(x);
}

vec4 saturate(vec4 v)
{
	v.x=clamp(v.x,0.0,1.0);
	v.y=clamp(v.y,0.0,1.0);
	v.z=clamp(v.z,0.0,1.0);
	v.w=clamp(v.w,0.0,1.0);
	return v;
}

vec3 saturate(vec3 v)
{
	v.x=clamp(v.x,0.0,1.0);
	v.y=clamp(v.y,0.0,1.0);
	v.z=clamp(v.z,0.0,1.0);
	return v;
}

float saturate(float x)
{
	x=clamp(x,0.0,1.0);
	return x;
}
//----------------------------------------------------------------------------------

vec3 blend2(vec3 left, vec3 right, float pos)
{
	vec3 res;
	res.r=left.r*(1.0-pos)+right.r*(pos);
	res.g=left.g*(1.0-pos)+right.g*(pos);
	res.b=left.b*(1.0-pos)+right.b*(pos);
	return res;
}
	
//----------------------------------------------------------------------------------

vec3 blend3(vec3 left, vec3 main, vec3 right, float pos)
{
	if(pos<0.0)
		return blend2(left,main,pos+1.0);
	else if (pos>0.0)
		return blend2(main,right,pos);
	else
		return main;
}

//----------------------------------------------------------------------------------

vec3 LightenColour(vec3 col, float lig)
{
	vec3 blk=vec3(0.0,0.0,0.0);
	vec3 wht=vec3(1.0,1.0,1.0);
	vec3 outcol;

	if(lig>0.0)
		outcol=blend2(col,wht,lig);				//mid to white 2 * ( 0-1 ) * (brt-1) + 1 
	else
		outcol=blend2(blk,col,1.0+lig);			//blk to mid   2 * ( 0-1 ) * (brt) - 1
	return outcol;
}

//----------------------------------------------------------------------------------

vec3 SaturateColour(vec3 col, float sat)
{
	float invr=(0.30)*(1.0-sat);
	float invg=(0.59)*(1.0-sat);
	float invb=(0.11)*(1.0-sat);
	float red=col.r*(invr+sat)+col.g*(invg)+col.b*(invb);
	float grn=col.r*(invr)+col.g*(invg+sat)+col.b*(invb);
	float blu=col.r*(invr)+col.g*(invg)+col.b*(invb+sat);
	vec3 outcol=vec3(red,grn,blu);
	return outcol;
}

//----------------------------------------------------------------------------------

vec3 ConvRGBtoHSV(vec3 RGB) 
{
    vec3 HSV = vec3(0.0,0.0,0.0);
    HSV.z = max(RGB.r, max(RGB.g, RGB.b));
    float M = min(RGB.r, min(RGB.g, RGB.b));
    float CC = HSV.z - M;
    if (CC != 0.0)
    {
        HSV.y = CC / HSV.z;
        vec3 Delta = (HSV.z - RGB) / CC;
        Delta.rgb -= Delta.brg;
        Delta.rg += vec2(2.0,4.0);
        if (RGB.r >= HSV.z)
            HSV.x = Delta.b;
        else if (RGB.g >= HSV.z)
			HSV.x = Delta.r;
        else
            HSV.x = Delta.g;
		HSV.x = frac(HSV.x / 6.0);
    }
	return HSV;
}

vec3 ConvHSVtoRGB(vec3 hsv)
{
	float R = abs(hsv.x * 6.0 - 3.0) - 1.0;
    float G = 2.0 - abs(hsv.x * 6.0 - 2.0);
    float B = 2.0 - abs(hsv.x * 6.0 - 4.0);
    vec3 scol=saturate(vec3(R,G,B));
	vec3 col=((scol-1.0)*hsv.y+1.0)*hsv.z;
	return col;
}

//----------------------------------------------------------------------------------

vec3 Colorize(vec3 col,vec3 tint,float sat,float lig)
{
	vec3 grey=vec3(0.5,0.5,0.5);
	vec3 midcol=blend2(grey,tint,sat*0.5);
	
	vec3 outcol;
	vec3 blk=vec3(0.0,0.0,0.0);
	vec3 wht=vec3(1.0,1.0,1.0);

	float value=col.r*0.30+col.g*0.59+col.b*0.11;		//input intensity 0-1
	if(lig>0.0)
		outcol=blend3(blk,midcol,wht,2.0*(1.0-lig)*(value-1.0)+1.0);		//mid to white 2 * ( 0-1 ) * (brt-1) + 1
	else
		outcol=blend3(blk,midcol,wht,2.0*(1.0+lig)*(value)-1.0);			//blk to mid   2 * ( 0-1 ) * (brt) - 1

	return outcol;
}

//----------------------------------------------------------------------------------

vec3 Overlay(vec3 src , vec4 col)
{
	vec3 outcol;

	if(src.r>0.5)
		outcol.r= (1.0 - (1.0-2.0*(src.r-0.5)) * (1.0-col.r));
	else
		outcol.r= ((2.0*src.r) * col.r);
	
	if(src.g>0.5)
		outcol.g= (1.0 - (1.0-2.0*(src.g-0.5)) * (1.0-col.g));
	else
		outcol.g= ((2.0*src.g) * col.g);
	
	if(src.b>0.5)
		outcol.b= (1.0 - (1.0-2.0*(src.b-0.5)) * (1.0-col.b));
	else
		outcol.b= ((2.0*src.b) * col.b);

	return src.rgb+col.a*(outcol.rgb-src.rgb);
}

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

#ifdef USEPHONG				//none of this if not phong
#ifdef LIGHTINGORREFLEC

struct Uber_cLightAndReflec
{
#ifdef USEDIFFUSELIGHTING
	 vec3	colour;
#endif
#ifdef USESPECULAR
	 vec3	colourSpec;
#endif	
#ifdef USEREFLECTION
	 vec3	reflecVec;
#endif
};



// work out lights and reflection vector for point - either in vertex shader or pixel shader

Uber_cLightAndReflec gLightAndReflec;
void Uber_DoLightsAndReflec(
						 vec3 pos_ms,									//pos in model space
						 vec3 nrm_ms)									//nrm in model space
{
	Uber_cLightAndReflec C;												//output
	
	vec3 pos_ws = ( modelMatrix * vec4(pos_ms,1.0)).xyz;				//pos in world space
	vec3 nrm_ws = ( modelMatrix * vec4(nrm_ms,0.0)).xyz;				//nrm in world space

#ifdef USEDIFFUSELIGHTING
	C.colour.rgb=lights_ambient.rgb;									//ambient
#endif
#ifdef USESPECULAR
	C.colourSpec.rgb=vec3(0.0);
#endif
#ifdef USEREFLECTION
	C.reflecVec.rgb=vec3(0.0);
#endif	

	nrm_ws=normalize(nrm_ws);
	
	vec3 ptoc_wsn = normalize(pos_ws.xyz-camPos.xyz);							//note used later in specular	
	
#ifdef USEREFLECTION
	C.reflecVec.rgb = normalize( reflect ( ptoc_wsn, nrm_ws ) );				//vector for cubemap lookup
	
#ifdef USEROTATEREFLECTION		//new
	float x2=C.reflecVec.x*reflecRotCos+C.reflecVec.y*reflecRotSin;
	float y2=C.reflecVec.y*reflecRotCos-C.reflecVec.x*reflecRotSin;
	C.reflecVec.x=x2;
	C.reflecVec.y=y2;
#endif

#ifdef USEROTREFLEC
	float q=C.reflecVec.y;
	C.reflecVec.y=C.reflecVec.z;
	C.reflecVec.z=-q;
#endif
#endif

	float NdotL;
	vec3 hv_wsn;
	float d;
	float specpow;
	vec3 L_wsn;
	vec3 r;
	vec3 ltop_ws;
	vec3 ltop_wsn;
	float fAtten;
	float LD;
	

//<#INSERTLIGHTS#>
	

#ifdef USEDIFFUSELIGHTING
	C.colour.rgb*=lightMaterial_diffuse.rgb;															//do ONCE now not in light accumulation code
#endif
#ifdef USESPECULAR
	C.colourSpec.rgb*=lightMaterial_specular.rgb;
#endif	

	gLightAndReflec=C;
	//return(C);
}

#endif		//if LIGHTINGORREFLEC
#endif		//if PHONG



//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

//----------------------------------------------------------------------------------

void main()
{

#ifdef PROGRAMTYPE_DEFAULT

	gl_FragColor=vec4(1.0,0.0,0.0,1.0);		//DEFAULT RED

#endif

#ifdef PROGRAMTYPE_SHADOWMAP

	vec4 outcol;
	outcol.r=v_position.z;				//test shader to see if it renders to texture
	outcol.g=v_position.z;				//test shader to see if it renders to texture
	outcol.b=v_position.z;				//test shader to see if it renders to texture
	outcol.a=1.0;
	gl_FragColor=outcol;

#endif

#ifdef PROGRAMTYPE_BUILD

	vec4 outcol;
	vec3 usenormal;
	vec4 decal;
	vec3 usecolour;
	vec3 useReflecVec;
	vec3 usecolourspec;
	vec4 decal2;
	vec4 temp;
	vec4 maskcol;

//----------------------------------------------------------------------------------
	
// temps for shader defined once so can be used multiple times

	vec3 tempHSV;			// temps for shader/effects defined once so can be used multiple times
	vec3 tempRGB;
	float tempV;
	float fog;
		
	vec3 pos_w;
	float dx;
	float dy;
	vec2 tc;
	vec4 overCol;
	vec3 xcol;

//----------------------------------------------------------------------------------

#ifdef USEPREPASS

	outcol.rgb = vec3(1.0,1.0,1.0);
#ifdef USEEARLYALPHATEST
	if (outcol.a-AlphaRef<0.0)	//alphaTest
    {
		discard;
	}		
#endif
	gl_FragColor=outcol;
	return;

#endif


#ifdef USESPECIAL


#ifdef USESPECIAL_AURORA 
	
	vec3 viewDirection = normalize(v_worldposition.xyz - camPos.xyz);		//world pos - cam pos
	
	vec3 rotNorm = normalize(( modelMatrix * vec4(v_normal.xyz,0.0)).xyz);					//need to be faster cant we pass rotated normal threough ?
	float dvn=dot(viewDirection, rotNorm);
	float Fresnel = saturate(pow(1.0 + c_FresnelBias + dvn, c_FresnelPower));
	vec4 tex=texture2D(s_texture1,  vec2(v_texCoords[0].x, v_texCoords[0].y + (c_fTime * c_ScrollSpeed)));	
	outcol= vec4(tex.rgb * (1.0- Fresnel) * v_blend.r * tex.a, 1.0);

#endif

#ifdef USESPECIAL_GLASS	

	Uber_DoLightsAndReflec(v_positionthro.xyz, v_normal.xyz);						
	Uber_cLightAndReflec C = gLightAndReflec;
	vec3 viewDirection = normalize(v_worldposition.xyz - camPos.xyz);		
	vec4 refl=textureCube(s_texture8, C.reflecVec) * lightMaterial_reflecMult;			
	float reflMask = pow((refl.x * 0.33) + (refl.y * 0.33) + (refl.z * 0.33), 2.0);
	float spec=C.colourSpec.r;

	// need the viewDirection dot the rotated normal
	vec3 rotNorm = normalize(( modelMatrix * vec4(v_normal.xyz,0.0)).xyz);			//was 1.0
	float dvn=dot(viewDirection, rotNorm);

	float matFresnel = saturate(pow(1.0 + c_uThickness + dvn , c_uMaterialFresnel));
	float reflFresnel = saturate(pow(1.0 + dvn, c_uReflectionFresnel));

	float alpha = saturate(matFresnel + (reflMask * reflFresnel) + spec);
	vec4 ccc=vec4(C.colour,1.0);
	vec4 color = lerp(ccc, refl, reflMask) ;
	color.rgb+=+ (C.colourSpec);
		
	outcol = vec4(color.rgb, alpha);
	
#endif





#ifdef FASTSHADER

	useReflecVec=v_reflecVec;
	vec4 reflection=textureCube(s_texture8, useReflecVec);					

#ifdef USESPECIAL_BEACH														// sand with wave

	float rMult=0.64;
	
	vec4 waterColour=c_depthColour;	

	float wavePhase = sin((c_fTime * TWOPIE * c_waveFrequency) + (v_blend.g * PIE));
	float wx=0.5 + v_texCoords[1].x * 0.5 + wavePhase * 0.10 -0.05;
	float wy=v_texCoords[1].y;
	vec4 waveTex=texture2D(s_texture4, vec2( wx,wy));	

	float wAlpha=waveTex.g ;
	float wHigh=waveTex.r * waveTex.g ;
	vec4 wHighCol=lightMaterial_diffuse * wHigh;
	
	vec4 sandTex=texture2D(s_texture1, v_texCoords[0]);			//lightMaterial_uDiffuseUVSet not set
	vec4 waterTex = (reflection*rMult)+waterColour + wHighCol;

	outcol.rgb = waterTex.rgb * (wAlpha) + sandTex.rgb * (1.0-wAlpha);

	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=shadow.rgb ;

#endif
	
#ifdef	USESPECIAL_SHALLOW													//ocean

	float lp=1.0-v_texCoords[1].x;

	float rMult=0.64*(1.0-lp)+lightMaterial_reflecMult*(lp);											//TODO interp from 0.64 - this MIGHT be the wrong way round....

	vec4 waterColour=c_depthColour*(1.0-lp)+texture2D(s_texture1, vec2(0.0,0.0))*(lp);				//TODO interp to c_depthColour

	outcol=(reflection*rMult)+waterColour;
	
	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=lerp(shadow.rgb,shadow.rgb*0.25+0.75,lp);										// refltex=0 want (shadow) refltex=1 want (shadow*0.25+0.75)

#endif
	
#ifdef	USESPECIAL_OCEAN													//ocean

	float rMult=lightMaterial_reflecMult;

	vec4 waterColour=texture2D(s_texture1, vec2(0.0,0.0));					
	
	outcol=(reflection*rMult)+waterColour;

	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=(shadow.rgb*0.25 + 0.75);														//shadowmap

#endif


#endif

//----------------------------------------------------------------------------------

#ifndef FASTSHADER

//----------------------------------------------------------------------------------

#ifdef USESPECIAL_BEACH

	vec4 tex=texture2D(s_texture1, v_texCoords[0]);									//lightMaterial_uDiffuseUVSet not set - this is the sand

	//vec4 reflTex=texture2D(s_texture5, v_texCoords[1]);								//the gradient
	vec4 reflTex=vec4(1.0-v_texCoords[1].x);
	reflTex.a=1.0;
	
	float wavePhase = sin((c_fTime * TWOPIE  * c_waveFrequency) + (v_blend.g * PIE ));

	float normalPhase = 1.0- sin(((c_fTime-1.0) * TWOPIE  * c_waveFrequency) + ((v_blend.g ) * PIE ));
	float wetPhase = 1.0 - frac(((c_fTime * c_waveFrequency) + (v_blend.g*0.5)) - 0.75);
	
	vec4 texN=texture2D(s_texture7, v_texCoords[1] + vec2(wavePhase * 0.1 * c_waveSpeed, 0.0));								//the waves coming in

	vec4 waveTex=texture2D(s_texture4,  vec2((v_texCoords[1].x * 0.5) + 0.5, v_texCoords[1].y) + vec2(wavePhase * 0.15 * (1.0 - v_blend.r), 0.0));					//the foam wave

	vec4 wetTex=texture2D(s_texture4, vec2((v_texCoords[1].x * 0.5) + (0.35), v_texCoords[1].y) );				//the foam wave

	vec3 localCoords = normalize(vec3(((2.0 * texN.rg) - 1.0) * lightMaterial_normalHeight * (0.2 + (saturate(normalPhase) * 0.8)), 1.0));				//the offset normal
		
//get normal and reflection 
	vec3 pos_ws = v_worldposition.xyz;
	vec3 ptoc_wsn = (pos_ws.xyz-camPos.xyz);			//note used later in specular	
	vec3 reflectedDir = reflect ( ptoc_wsn, localCoords ) ;					//vector for cubemap lookup - no need to normalize ?
//get normal and reflection 

#ifdef USEROTATEREFLECTION	//new
	float x2=reflectedDir.x*reflecRotCos+reflectedDir.y*reflecRotSin;
	float y2=reflectedDir.y*reflecRotCos-reflectedDir.x*reflecRotSin;
	reflectedDir.x=x2;
	reflectedDir.y=y2;
#endif

	vec4 cubeMap=textureCube(s_texture8, reflectedDir);
			
	float wetSandM = 1.0 - saturate((wetTex.g *  wetPhase)-0.1);
	vec4 wetSand = lerp(lightMaterial_diffuse,vec4(1.0,1.0,1.0,1.0),wetSandM);
	float waveRefAmount = 0.3;

	float waveFoamMask = waveTex.g * waveTex.r * (1.0 - wavePhase) * (1.0 - reflTex.x);

	vec4 sand = lerp(tex * wetSand, lerp(tex, c_depthColour, reflTex.x), waveTex.g);

	vec4 diff = lerp(sand, vec4(1.0, 1.0, 1.0, 1.0), waveFoamMask);

	vec4 refl = cubeMap * waveTex.g * waveRefAmount * (1.0 - waveFoamMask);

	outcol=diff + refl;
		
	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=shadow.rgb ;

#endif

//----------------------------------------------------------------------------------

#ifdef USESPECIAL_SHALLOW

	float wavePhase = sin((c_fTime * TWOPIE  * c_waveFrequency) + (v_blend.g * PIE ));
	
	float normalPhase = 1.0-sin(((c_fTime+1.0) * TWOPIE  * c_waveFrequency) + ((v_blend.g ) * PIE ));
	
	vec4 tex=texture2D(s_texture1, v_texCoords[0]);									//lightMaterial_uDiffuseUVSet not set

	vec4 reflTex=texture2D(s_texture5, v_texCoords[1]);								//the gradient

	vec4 normaldelta1=texture2D(s_texture7,vec2(v_texCoords[0].x+c_uvDeltaU1,v_texCoords[0].y+c_uvDeltaV1));			
	vec4 normaldelta2=texture2D(s_texture7,vec2((v_texCoords[0].x+c_uvDeltaU2)*c_uvMultiply,(v_texCoords[0].y+c_uvDeltaV2)*c_uvMultiply));			
	vec4 texN=(normaldelta1+normaldelta2)*0.5;									

	vec4 texN3=texture2D(s_texture3, v_texCoords[1] + vec2(wavePhase * 0.1 * c_waveSpeed, 0.0));								//the waves coming in

	vec2 n1=((2.0*texN.rg)-1.0) *  lightMaterial_normalHeight;
	vec2 n2=((2.0*texN3.rg)-1.0) *  c_waveIntensity * (0.2 + (saturate(normalPhase) * 0.8) );
	vec3 localCoords = vec3 ( n1 * reflTex.x + n2* (1.0 - reflTex.x),1.0);
	
	//get normal and reflection 
	vec3 pos_ws = v_worldposition.xyz;
	vec3 ptoc_wsn = (pos_ws.xyz-camPos.xyz);			//note used later in specular	
	vec3 reflectedDir = reflect ( ptoc_wsn, localCoords ) ;					//vector for cubemap lookup - no need to normalize ?
	//get normal and reflection 

#ifdef USEROTATEREFLECTION	//new
	float x2=reflectedDir.x*reflecRotCos+reflectedDir.y*reflecRotSin;
	float y2=reflectedDir.y*reflecRotCos-reflectedDir.x*reflecRotSin;
	reflectedDir.x=x2;
	reflectedDir.y=y2;
#endif

	vec4 cubeMap=textureCube(s_texture8, reflectedDir);
		
	vec4 waterColour=texture2D(s_texture1, vec2(0.0,0.0));					//NEW EDITED4
	
	float waterReflAmount = 0.3;

	vec4 refl = cubeMap * lerpfloat(waterReflAmount, lightMaterial_reflecMult, reflTex.x);
	vec4 diff = lerp(c_depthColour, waterColour, reflTex.x);
	
	outcol = diff+refl;

	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=lerp(shadow.rgb,shadow.rgb*0.25+0.75,reflTex.x);		// refltex=0 want (shadow) refltex=1 want (shadow*0.25+0.75)

#endif		//USESPECIAL_SHALLOW

//----------------------------------------------------------------------------------

#ifdef USESPECIAL_OCEAN

// get average normal deltaof two scrolling uvs

	vec4 normaldelta1=texture2D(s_texture7,vec2(v_texCoords[0].x+c_uvDeltaU1,v_texCoords[0].y+c_uvDeltaV1));			
	vec4 normaldelta2=texture2D(s_texture7,vec2((v_texCoords[0].x+c_uvDeltaU2)*c_uvMultiply,(v_texCoords[0].y+c_uvDeltaV2)*c_uvMultiply));			
	vec4 texN=(normaldelta1+normaldelta2)*0.5;									
	vec2 n1=((2.0*texN.rg)-1.0)*lightMaterial_normalHeight* (1.0-v_blend.b);
	vec3 localCoords = vec3 (n1,1.0);

	//get normal and reflection 
	vec3 pos_ws = v_worldposition.xyz;
	vec3 ptoc_wsn = (pos_ws.xyz-camPos.xyz);			//note used later in specular	
	vec3 reflectedDir = reflect ( ptoc_wsn, localCoords ) ;					//vector for cubemap lookup - no need to normalize ?
	//get normal and reflection 

#ifdef USEROTATEREFLECTION		//new
	float x2=reflectedDir.x*reflecRotCos+reflectedDir.y*reflecRotSin;
	float y2=reflectedDir.y*reflecRotCos-reflectedDir.x*reflecRotSin;
	reflectedDir.x=x2;
	reflectedDir.y=y2;
#endif

	outcol=textureCube(s_texture8, reflectedDir);

	outcol.rgb*= lightMaterial_reflecMult;												//NEW EDITED

	vec4 waterColour=texture2D(s_texture1, vec2(0.0,0.0));					//NEW EDITED
	outcol+=waterColour;

	//shadow
	vec4 shadow=texture2D(s_texture2, v_texCoords[2])* lightMaterial_shadowMult;					//1 Lightmap  lightMaterial_uShadowUVSet not set
	outcol.rgb*=(shadow.rgb*0.25 + 0.75);														//shadowmap


#endif		//USESPECIAL_OCEAN

//----------------------------------------------------------------------------------

#endif		//#ifndef FASTSHADER

//----------------------------------------------------------------------------------

#endif		//#ifndef USESPECIAL

//----------------------------------------------------------------------------------

#ifndef USESPECIAL

//----------------------------------------------------------------------------------


//----------------------------------------------------------------------------------

//MOVEDHERE
// main texture

//----------------------------------------------------------------------------------

#ifdef USESNOW
	vec4 m1=texture2D(s_texture3, v_worldposition.xy*c_SnowMask1Scaling);	
	vec4 m2=texture2D(s_texture3, v_worldposition.xy*c_SnowMask2Scaling);	
	vec4 sn=texture2D(s_texture4, v_worldposition.xy*c_SnowTexScaling);	
	vec4 gr=texture2D(s_texture1, v_texCoords[0]);
	float finalM=saturate((((m1.r+m2.r+gr.g+(saturate(v_blend.b-0.5)*2.0))*saturate(v_blend.b*2.0))-0.5)*10.0);
	vec4 surf=lerp(gr,sn,finalM);
	outcol.rgb=surf.rgb;
	//outcol.rgb=vec3(1.0);		//above to do
#endif

//----------------------------------------------------------------------------------
	
#ifndef USESNOW

	outcol=vec4(1.0);

#ifdef DIFFUSEMAPENABLE
	outcol=texture2D(s_texture1, v_texCoords[lightMaterial_uDiffuseUVSet]);							
#endif

#ifdef TEXBLEND2D_T1
	outcol=texture2D(s_texture1, v_texCoords[0]);	
#endif

#ifdef TEXBLEND2D_T1_X_C1
	outcol=texture2D(s_texture1, v_texCoords[0]);
#endif

#ifdef TEXBLEND2D_SPEEDTEST
	outcol=texture2D(s_texture1, v_texCoords[0]);		//to do , complicate this shader to slow stuff down
	outcol.rgb = ( modelMatrix * vec4(outcol.rgb,1.0)).xyz;
	outcol.r=1.0-outcol.r;
	outcol.rgb = ( modelMatrix * vec4(outcol.rgb,1.0)).xyz;
	outcol.g=1.0-outcol.g;
	outcol.rgb = ( modelMatrix * vec4(outcol.rgb,1.0)).xyz;
#endif

#ifdef TEXBLEND2D_T1_X_C1_MULTIPLY
	vec4 colMul=texture2D(s_texture1, v_texCoords[0]) * v_vertcol;
	outcol.rgb = colMul.rgb + ( ( vec3(1.0,1.0,1.0) - colMul.rgb ) * ( 1.0 - colMul.a ) );
#endif

#ifdef TEXBLEND2D_T1_X_C1_SCREEN
	outcol=texture2D(s_texture1, v_texCoords[0]);
	outcol.rgb *= v_vertcol.rgb * v_vertcol.a * outcol.a;
#endif

#ifdef TEXBLEND2D_T1_X_C1_SNOW
	outcol=texture2D(s_texture1, v_texCoords[0]);	
	outcol.rgb*=textureCube(s_texture8, camZDir.xyz).rgb;
#endif 

#ifdef TEXBLEND2D_T1_X_C1_RA
	outcol.a=texture2D(s_texture1, v_texCoords[0]).r;
#endif

#ifdef TEXBLEND2D_T1_X_C1_GA
	outcol.a=texture2D(s_texture1, v_texCoords[0]).g;
#endif

#ifdef TEXBLEND2D_T1_X_T2
	outcol=texture2D(s_texture1, v_texCoords[0]);
	decal2=texture2D(s_texture2, v_texCoords[1]);
	outcol=outcol*decal2;
#endif

#ifdef TEXBLEND2D_T1_X_C1_MASK
	outcol=texture2D(s_texture1, v_texCoords[0]) ;
	maskcol=texture2D(s_texture2, v_texCoords[1]);
	outcol.a*=maskcol.a;
#endif

#ifdef TEXBLEND2D_C1
	outcol=texture2D(s_texture1, v_texCoords[0]);	
	outcol.rgb=vec3(1.0);				
#endif

#ifdef TEXBLEND2D_T1_X_C2
	outcol=texture2D(s_texture1, v_texCoords[1]);				//the one to use for colour
	maskcol=texture2D(s_texture2, v_texCoords[0]);				//the 'split' alpha
	outcol.a=maskcol.a*outcol.a;
#endif

#ifdef VSUSECOLOUR							// all of the above
#ifndef TEXBLEND2D_T1_X_C1_MULTIPLY
#ifndef TEXBLEND2D_T1_X_C1_SCREEN
	outcol=outcol* v_vertcol;
#endif
#endif
#endif

#ifdef TEXBLENDDIVALPHA
	outcol.rgb/=outcol.a;
#endif

#ifdef TEXBLENDLIGHTMAP
	outcol.rgb=outcol.rgb*outcol.a+vec3(0.5,0.5,0.5)*(1.0-outcol.a);	
#endif

//----------------------------------------------------------------------------------

// blended to second

#ifdef VSUSEVCOLOUR
#ifdef USEDIFFUSEMAP2
#ifdef USEGRASSSHADER									//grass only
#ifdef DEBUGGRASSBLEND
#ifdef GRASSBLENDABLE

#ifdef USEGRASSBLEND		//theres a blend factor, i.e. blend != 1 - blend 1 = no blend to distance, blend 0 = full distance

#ifdef USEGRASSGREEN
	vec2 wuv=v_worldposition.xy * vec2(-1.0, 1.0) * 0.5;		//world uv
	float amt=RangeCol.a;										//amt of "far" decal, so this 0 close 1 far
	vec4 decal2x=texture2D(s_texture4, wuv );					//the texture on the floor mesh, roughly
	vec3 chequer=2.0*texture2D(s_texture7,wuv).rgb;				//chequerboard for green
	outcol.rgb=outcol.rgb*chequer*(amt) + decal2x.rgb*(1.0-amt);
	//outcol.rgb=vec3(0.0,0.0,1.0);
#endif

#ifndef USEGRASSGREEN
	vec2 wuv=v_worldposition.xy * vec2(-1.0, 1.0) * 0.5;		//world uv
	float amt=RangeCol.a;										//amt of "far" decal, so this 0 close 1 far
	vec4 decal2x=texture2D(s_texture4, wuv );					//the texture on the floor mesh, roughly
	vec3 chequer=2.0*lightMaterial_diffuse.rgb;					//chequerboard for green from swatch
	outcol.rgb=outcol.rgb*chequer*(amt) + decal2x.rgb*(1.0-amt);
	//outcol.rgb=vec3(0.0,0.0,1.0);
#endif

#endif

#ifndef USEGRASSBLEND		//RangeCol.a = 1, up close, no blend to distance

#ifdef USEGRASSGREEN
	vec2 wuv=v_worldposition.xy * vec2(-1.0, 1.0) * 0.5;		//world uv
	vec3 chequer=2.0*texture2D(s_texture7,wuv).rgb;				//chequerboard for green
	outcol.rgb=outcol.rgb*chequer;
	//outcol.rgb=float3(1.0,1.0,0.0);
#endif

#ifndef USEGRASSGREEN
	vec3 chequer=2.0*lightMaterial_diffuse.rgb;					//chequerboard for green from swatch
	outcol.rgb=outcol.rgb*chequer;
	//outcol.rgb=vec3(0.0,0.0,1.0);
#endif

#endif

#endif
#endif
#endif

#ifdef USEBLENDDIFFMAPS										//normal blended bits
	vec4	decal2x=texture2D(s_texture4, v_texCoords[lightMaterial_uDiffuse2UVSet]);					//used for blending diff maps AND for second tex on grass		
	vec4	decalx=texture2D(s_texture4, v_texCoords[1]);						
	outcol.rgb=outcol.rgb*(decalx.a) + decal2x.rgb*(1.0-decalx.a);

#endif
#endif
#endif

//----------------------------------------------------------------------------------

#endif		//ifndef USESNOW
//MOVEDHERE
//----------------------------------------------------------------------------------
//NEW

#ifdef USEEARLYALPHATEST

#ifdef TEXBLEND2D_UBER
	if (outcol.a-AlphaRef<0.0)	//alphaTest
    {
		discard;
	}
#endif
#ifndef TEXBLEND2D_UBER
	if (outcol.a-0.5<0.0)		//alphaTest for 2d
    {
		discard;
	}
#endif
	
#endif

//NEW
//----------------------------------------------------------------------------------
// if phong, get interpolated normal, if normal map, adjust it
//----------------------------------------------------------------------------------

#ifdef USEPHONG
	usenormal=v_normal.xyz;
#ifdef VSUSETANGENTS
#ifdef USENORMALMAP
	mat3 tbn = mat3(v_tangent.xyz,v_binormal.xyz,usenormal);
	vec4 normaldelta=texture2D(s_texture7, v_texCoords[lightMaterial_uNormalUVSet]);					//normal delta map
	vec3 pixoff= normalize( normaldelta.xyz * 2.0 - 1.0 );
	pixoff.xy*=lightMaterial_normalHeight;
	vec3 pixelNormal = tbn * pixoff ;															//other way round
	usenormal=pixelNormal;																			
#endif
#endif
#endif


//----------------------------------------------------------------------------------
// work out colour, spec and ereflec - either interpolated or reworked out per pixel
//----------------------------------------------------------------------------------

#ifndef USEPHONG
#ifdef USEDIFFUSELIGHTING
	usecolour=v_colour.rgb;																	
#endif
#ifdef USESPECULAR
	usecolourspec=v_colourSpec.rgb;
#endif
#ifdef USEREFLECTION
	useReflecVec=v_reflecVec.xyz;
#endif
#endif

#ifdef USEPHONG
#ifdef LIGHTINGORREFLEC
	Uber_DoLightsAndReflec(v_positionthro.xyz, usenormal.xyz);						// override interpolated values
	Uber_cLightAndReflec C = gLightAndReflec;
#ifdef USEDIFFUSELIGHTING
	usecolour=C.colour;
#endif
#ifdef USESPECULAR
	usecolourspec=C.colourSpec;
#endif
#ifdef USEREFLECTION
	useReflecVec=C.reflecVec;
#endif
#endif
#endif

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// lighting

#ifndef USESNOW

//----------------------------------------------------------------------------------

#ifdef USELIGHTMATERIAL

#ifdef USEDIFFUSELIGHTING
	outcol.rgb=outcol.rgb*usecolour.rgb;																// this is the calculated lighting
	outcol.a=outcol.a*lightMaterial_ambient.a;
#endif
#ifndef USEDIFFUSELIGHTING
#ifndef USEGRASSSHADER		//TOCOPYto FSH
	outcol.rgb*=lightMaterial_diffuse.rgb;			//the new line
#endif
#endif

#endif		//USELIGHTMATERIAL

//----------------------------------------------------------------------------------

#endif		//ifndef USESNOW

//----------------------------------------------------------------------------------
// shadowmap
//----------------------------------------------------------------------------------

#ifdef SHADOWMAPENABLE
	vec4 shadow=texture2D(s_texture2, v_texCoords[lightMaterial_uShadowUVSet]);						//T1(0-7) //Lightmap
	outcol.rgb*=shadow.rgb * lightMaterial_shadowMult ;
#endif
	
//----------------------------------------------------------------------------------
// add reflection
//----------------------------------------------------------------------------------
	
#ifdef USEREFLECTION
	vec4 reflection=textureCube(s_texture8, useReflecVec.xyz);								//TODO CUBE !!! 
	float rf=lightMaterial_reflecMult;
	vec3 rc=vec3(rf);
#ifdef USESNOW
	rc*=finalM;
#endif
#ifdef USEREFLECTIONINTENSITYMAP
	vec4 reflectivity=texture2D(s_texture5, v_texCoords[lightMaterial_uReflectionIntensityUVSet]);	//);			//T4(0-7)				
	rc*=reflectivity.rgb;
#endif
	//vec3 irc=vec3(1.0-rc.x,1.0-rc.y,1.0-rc.z);
	//outcol.rgb=(outcol.rgb*(irc))+(reflection.rgb*(rc));
	outcol.rgb=outcol.rgb+(reflection.rgb*(rc));
#endif
	
//----------------------------------------------------------------------------------
// add specular
//----------------------------------------------------------------------------------
	
#ifdef USESPECULAR
#ifdef USESPECULARINTENSITYMAP
	 vec4 speccol=texture2D(s_texture3, v_texCoords[lightMaterial_uSpecularIntensityUVSet]);	//);				//T2(0-7)  spec int
	outcol.rgb+=usecolourspec.rgb * speccol.rgb;
#endif		
#ifndef USESPECULARINTENSITYMAP
	outcol.rgb+=usecolourspec.rgb;
#endif
#endif
	
//----------------------------------------------------------------------------------
// add emissive
//----------------------------------------------------------------------------------
	
#ifdef USEEMISSIVE																
#ifdef USEEMISSIVEMAP
	vec4 emisscol=texture2D(s_texture6, v_texCoords[lightMaterial_uEmissiveUVSet]);	
	outcol.rgb+=lightMaterial_emissive.rgb * emisscol.rgb;
#endif
#ifndef USEEMISSIVEMAP
	outcol.rgb+=lightMaterial_emissive.rgb;
#endif
#endif

//----------------------------------------------------------------------------------

#endif //#ifndef USESPECIAL

//----------------------------------------------------------------------------------


//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

//common

#ifdef	USEGRASSSHADER			//all grass
#ifdef DEBUGGRASSCLIP
	if(v_blend.b - RangeCol.x <0.0)			
	{
		discard;
	}
#endif
#endif

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
	
	//Okay LG phone won't upload the lightmaterial array correctly without this line
	//It's like by not using the last vec4 in the array something gets optimized out and breaks things
	//shows as the golf arc going wrong (grey)

#ifdef PLATFORM_AND
	outcol.r+=0.0*lightMaterial_mulcol.r;
#endif

#ifdef PREMULCOLENABLE
	outcol.rgba*=MulCol.rgba;		//PreMulCol now - use for objects in model
#endif

#ifdef PREHIGHLIGHTENABLE
	outcol.rgb+=(Highlight.rgb-outcol.rgb)*Highlight.w;		//PreHighlight now - use for  objects
#endif

#ifdef USESHADOWMAP

	vec2 projectTexCoord;															// assuming that this is in proj space			
	projectTexCoord.x=(0.5+(0.5*v_position_lig.x/v_position_lig.w));
	projectTexCoord.y=(0.5+(0.5*v_position_lig.y/v_position_lig.w));		//two -s cancel out

//	projectTexCoord.x=0.5+0.5*v_position.x/v_position.w;		//actual screen pos converted into 0/1 texture
//	projectTexCoord.y=0.5+0.5*v_position.y/v_position.w;
//	outcol.r+=projectTexCoord.x;								//seems to move round, so suggests that the uvs are correct
//	outcol.g+=projectTexCoord.y;
	
//	if(0)		//(saturate(projectTexCoord.x) == projectTexCoord.x) && (saturate(projectTexCoord.y) == projectTexCoord.y))
    {
		vec4 tex=texture2D(s_texture6, projectTexCoord);		

		float lightDepthValue = v_position_lig.z / v_position_lig.w;		//hmm this may be -1 +1 on GL
		float depthValue=tex.r;
		if(lightDepthValue-0.01 > depthValue)
        {
			outcol.rgb *=0.5;
		}
	}

#endif



#ifdef USEGREENFRESNEL		

	vec3 viewDirection7 = normalize(v_worldposition.xyz - camPos.xyz);		//world pos - cam pos
	vec3 rotNorm7 = v_normalrot.xyz;
	float dvn7=dot(viewDirection7, rotNorm7);
	float matFresnel7 = pow(1.0 +c_uGreenFresnelBias + dvn7 , c_uGreenFresnelPower);		//hmm, we dont want saturate here do we ?
	outcol.r+=matFresnel7*c_uGreenFresnelRed;
	outcol.g+=matFresnel7*c_uGreenFresnelGreen;
	outcol.b+=matFresnel7*c_uGreenFresnelBlue;

#endif

#ifdef USESPECIAL_AUTUMN

	vec3 diffuse1 = texture2D(s_texture1 , v_texCoords[0]).rgb;
	vec4 diffuse2 = texture2D(s_texture4, v_texCoords[0] * 0.5);
	vec3 overlay1 = texture2D(s_texture7, v_texCoords[0] * 0.25).rgb;
	vec3 overlay2 = texture2D(s_texture5, v_texCoords[0] * 0.01).rgb;
	float blend1  = texture2D(s_texture3, v_texCoords[0] * 0.058).r;
	float blend2  = texture2D(s_texture3, v_texCoords[0] * 0.02).r;
	vec3 shadow   = texture2D(s_texture2, v_texCoords[2]).rgb * lightMaterial_shadowMult;

	vec3 leafTex = diffuse2.rgb * overlay1 * overlay2 * 4.0;

	float vColBlueHi = saturate(clamp(v_blend.b, 0.0, 0.55) - 0.5) * 2.0;
	float vColBlueLo = saturate(clamp(v_blend.b, 0.0, 0.55) * 2.0);
	float leafMask = saturate(pow((saturate((blend1 * blend2 * diffuse2.a * 4.0 * vColBlueLo) + vColBlueHi) + 0.5), 30.0) - 0.5);

	outcol.rgb = (diffuse1 * (1.0 - leafMask)) + (leafTex * leafMask); 
	outcol.rgb*=shadow; 

#endif


	//<#INSERTSHADEREFFS#>

	//<#INSERTOVERLAY#>



	gl_FragColor=outcol;

//----------------------------------------------------------------------------------

#endif		//PROGRAMTYPE_BUILD

}



//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

#ifdef PASTEINCODE		// pasted in code - only definition

/*<ShaderEff>

#ifdef USESHADEREFFMULCOL<n>
	outcol.rgba *= shadData_colour(n);
#endif

#ifdef USESHADEREFFADDCOL<n>
	outcol.rgba += shadData_colour(n);
#endif

#ifdef USESHADEREFFSATURATE<n>
	outcol.rgb=SaturateColour(outcol.rgb,shadData_sat(n));
#endif

#ifdef USESHADEREFFBLENDCOL<n>
	outcol.rgb+=(shadData_colour(n).rgb-outcol.rgb)*shadData_colour(n).a;		//sat(n);
#endif

#ifdef USESHADEREFFCOLORIZE<n>
	outcol.rgb=Colorize(outcol.rgb,shadData_colour(n).rgb,shadData_sat(n),shadData_lig(n));
#endif

#ifdef USESHADEREFFOVERLAY<n>
	outcol.rgb=Overlay(outcol.rgb,shadData_colour(n));
#endif

#ifdef USESHADEREFFHUESHIFT<n>
	tempHSV=ConvRGBtoHSV(outcol.rgb);		// convert from RGB to HSV
	tempHSV.x+=shadData_hue(n);				//hue DELTA was offset to 0.5 not now
	tempHSV.x-=floor(tempHSV.x);
	tempRGB=ConvHSVtoRGB(tempHSV);
	tempRGB=SaturateColour(tempRGB,shadData_sat(n));		//now saturate
	outcol.rgb=LightenColour(tempRGB,shadData_lig(n));		//and lighten
#endif

#ifdef USESHADEREFFCONTRAST<n>
	outcol.rgb = ((outcol.rgb - 0.5) * shadData_sat(n)) + 0.5;
#endif
	
#ifdef USESHADEREFFADDCOLPROP<n>
	tempV=outcol.r*0.30+outcol.g*0.59+outcol.b*0.11;		//input intensity 0-1
	outcol.rgb+=shadData_colour(n).rgb*tempV;
#endif

#ifdef USESHADEREFFFOG<n>
	//fog=saturate((v_position.z-shadData_sat(n))/(shadData_lig(n)-shadData_sat(n)));		//v_position.z is actual distance
	fog=saturate((v_position.z-shadData_sat(n))*shadData_hue(n));			
#ifdef USESPECIAL_OCEAN
	fog=fog*(1.0-v_blend.r);
#endif				
	outcol.rgb+=(shadData_colour(n).rgb-outcol.rgb)*fog*shadData_colour(n).a;
#endif

#ifdef USESHADEREFFFOG2<n>
	//fog=saturate((v_position.z-shadData_sat(n))*shadData_hue(n));			//v_position.z is actual distance
	{
	float camDist = v_position.z;
	float fogStart = shadData_sat(n);
	float fogMid = shadData_hue(n);
	float fogEnd = shadData_lig(n);
	float brightness = (outcol.r * 0.33) + (outcol.g * 0.33) + (outcol.b * 0.33);
	brightness = saturate(((brightness - 0.5) * 2.0) + 0.5);
	float haze = saturate((camDist - fogStart) / (fogMid - fogStart));
	float hazeMask = lerpfloat(0.0, 1.0 - brightness, haze);
	float trueFog = saturate((camDist - fogMid) / (fogEnd - fogMid));
	fog=saturate(hazeMask + trueFog);
	}
#ifdef USESPECIAL_OCEAN
	fog=fog*(1.0-v_blend.r);
#endif
	outcol.rgb+=(shadData_colour(n).rgb-outcol.rgb)*fog*shadData_colour(n).a;
#endif

*/


/*<DirectionalLight>

#ifdef USELIGHT<n>

#ifndef USEPOINT<n>
			NdotL = dot(nrm_ws, -light_direction(n).xyz);
			if (NdotL>0.0)														//only add if light dot normal > 0, else point facing away from light
			{
#ifdef USEDIFFUSELIGHTING
				C.colour.rgb+= NdotL * light_diffuse(n).rgb;					//diffuse - dont mul by material diffuse colour until later
#endif
#ifdef USESPECULAR
#ifdef USESPECULAR<n>
#ifdef FASTSPEC
				hv_wsn=normalize(-light_direction(n).xyz - ptoc_wsn);			//todo interpolate this
				d = dot ( hv_wsn , nrm_ws);	
				specpow=pow(max(0.0, d), lightMaterial_specularpower*4.0);
#endif
#ifndef FASTSPEC
				L_wsn=-light_direction(n).xyz;
				r=normalize(reflect(L_wsn.xyz,nrm_ws));
				d = dot ( ptoc_wsn , r);										//dot the angle
				specpow=pow(max(0.0, d), lightMaterial_specularpower);
#endif
				C.colourSpec.rgb+= specpow * light_specular(n).rgb;				//dont mul by material specular colour until later
#endif
#endif
			}
#endif


#ifdef USEPOINT<n>
			
			ltop_ws=light_position(n).xyz-pos_ws.xyz;							//light to pos world space
			ltop_wsn=normalize(ltop_ws);										//normalised
			NdotL=dot(nrm_ws,ltop_wsn);											//dot to see if light facing normal
			if (NdotL>0.0)														//Must be facing for anything at all
			{
				LD=length(ltop_ws);
				if (LD<=light_range(n))
				{
					fAtten=saturate(light_attenuation0(n) + light_attenuation1(n)*LD );
#ifdef USEDIFFUSELIGHTING
					C.colour.rgb+=NdotL * light_diffuse(n).rgb * fAtten;
#endif				
#ifdef USESPECULAR
					r=normalize(reflect(ltop_wsn,nrm_ws));
					d = dot ( ptoc_wsn , r);										//dot the angle
					specpow=pow(max(0.0, d), lightMaterial_specularpower);
					C.colourSpec.rgb+= specpow * light_specular(n).rgb * fAtten;	//dont mul by material specular colour until later
#endif
				}
			}
			
#endif
			
#endif

*/		


/*<Overlay>

#ifdef USEOVERLAY<n>

#ifdef NEWOVERLAY
	dx=v_overlay<n>[0];
	dy=v_overlay<n>[1];
	if(dx*dx+dy*dy<=1.0)
#endif
#ifndef NEWOVERLAY
	pos_w = v_worldposition.xyz;
	dx=(pos_w.x-c_ovPosX<n>)/c_ovSize<n>;
	dy=(pos_w.y-c_ovPosY<n>)/c_ovSize<n>;
	if(dx*dx+dy*dy<=1.0)
#endif
	//if(dx>=-1.0)
	{
		//if(dx<=+1.0)
		{
			//if(dy>=-1.0)
			{
				//if(dy<=+1.0)
				{
					tc.x=(-dx+1.0)*0.5;
					tc.y=(-dy+1.0)*0.5;
					overCol=texture2D(s_texture<m>, tc);		

#ifdef USEOVERLAYCOLORIZE<n>
					xcol=Colorize(outcol.rgb,overCol.rgb,c_ovSat<n>,c_ovLig<n>);
					outcol.rgb=outcol.rgb+(xcol.rgb-outcol.rgb)*overCol.a*c_ovAlpha<n>;
#endif

#ifdef USEOVERLAYTARGET<n>
					float da=saturate(2.0*(overCol.g+overCol.r+overCol.b-0.3));		//black ring goes to 0, all others go to 1
					outcol.rgb-=da*overCol.a*0.3*c_ovAlpha<n>;
					outcol.rgb+=da*overCol.rgb*overCol.a*c_ovAlpha<n>;
					//outcol.rgb+=da*overCol.a*(overCol.rgb-0.3)*c_ovAlpha<n>;;						//NOTE This DOES use *c_ovAlpha<n>;
#endif

#ifdef USEOVERLAYADD<n>
					outcol.rgb+=overCol.rgb*overCol.a*c_ovAlpha<n>;
#endif
				}
			}
		}
	}

#endif

*/


#endif  //PASTEINCODE

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
