//  Shader_3D_UBER.vsh

precision highp float;


#ifdef USEDIFFUSELIGHTING
#define LIGHTINGORREFLEC
#endif
#ifdef USEREFLECTION
#ifndef LIGHTINGORREFLEC
#define LIGHTINGORREFLEC
#endif
#endif
#ifdef USESPECULAR
#ifndef LIGHTINGORREFLEC
#define LIGHTINGORREFLEC
#endif
#endif

#ifdef USEPHONG
#define PASSPOSITIONTHRO
#endif

/*
#ifndef PASSPOSITIONTHRO
#ifdef USEOVERLAY0
#define PASSPOSITIONTHRO
#endif
#endif
#ifndef PASSPOSITIONTHRO
#ifdef USEOVERLAY1
#define PASSPOSITIONTHRO
#endif
#endif
#ifndef PASSPOSITIONTHRO
#ifdef USEOVERLAY2
#define PASSPOSITIONTHRO
#endif
#endif
#ifndef PASSPOSITIONTHRO
#ifdef USEOVERLAY3
#define PASSPOSITIONTHRO
#endif
#endif
*/


#ifndef WORLDPOSITION
#ifdef USEOVERLAY0
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY1
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY2
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USEOVERLAY3
#define WORLDPOSITION
#endif
#endif

#ifndef WORLDPOSITION
#ifdef USESPECIAL_OCEAN
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_BEACH
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_SHALLOW
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_GLASS
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESPECIAL_AURORA
#define WORLDPOSITION
#endif
#endif
#ifndef WORLDPOSITION
#ifdef USESNOW
#define WORLDPOSITION
#endif
#endif

#ifndef WORLDPOSITION
#ifdef USEGRASSSHADER
#define WORLDPOSITION
#endif
#endif

#ifndef WORLDPOSITION
#ifdef USEGREENFRESNEL
#define WORLDPOSITION
#endif
#endif
// This is the vertex INPUT data, pure mesh vertices. The vertex shader takes this in for each vertex, proxesses it and outputs it, interpolated into the pixel shader

#ifdef VSUSEPOSITION
attribute highp vec4 a_position;
#endif

#ifdef VSUSECOLOUR
attribute lowp vec4 a_colour;
#endif

#ifdef VSUSENORMAL	
attribute highp vec4 a_normal;		//TODO 3
#endif	
#ifdef VSUSETANGENTS
attribute highp vec4 a_tangent;
attribute highp vec4 a_binormal;
#endif
#ifdef VSUSEBONES
attribute  highp vec4 a_boneweights;
attribute highp vec4 a_boneindices;
#endif


#if defined(VSUSETEX1) || defined(VSUSETEX2)
attribute highp vec4 a_texCoord12;
#endif
#if defined(VSUSETEX3) || defined(VSUSETEX4)
attribute highp vec4 a_texCoord34;
#endif

#ifdef VSUSEVCOLOUR
attribute highp vec4 a_vcolour;
#endif


// This is the vertex OUTPUT data which gets interpolated and fed into pixel shader per scanned screen pixel

#ifdef VSUSEPOSITION
varying highp vec4 v_position;
#endif
#ifdef VSUSEPOSITIONSMAP
varying highp vec4 v_position_lig;
#endif

#ifdef USEPHONG
varying highp vec3 v_normal;
#endif
#ifdef USEGREENFRESNEL
varying highp vec3 v_normalrot;
#endif

#ifdef PASSPOSITIONTHRO
varying highp vec4 v_positionthro;
#endif
#ifdef WORLDPOSITION
varying highp vec4 v_worldposition;
#endif

#ifdef NEWOVERLAY
#ifdef USEOVERLAY0
varying highp vec2 v_overlay0;
#endif
#ifdef USEOVERLAY1
varying highp vec2 v_overlay1;
#endif
#ifdef USEOVERLAY2
varying highp vec2 v_overlay2;
#endif
#ifdef USEOVERLAY3
varying highp vec2 v_overlay3;
#endif
#endif

#ifdef VSUSETANGENTS
varying highp vec3 v_tangent;
varying highp vec3 v_binormal;
#endif

#ifdef VSUSECOLOUR
varying highp vec4 v_vertcol;
#endif

#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifdef VSUSETEX3
#ifdef VSUSETEX4
varying highp vec2 v_texCoords[4];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifdef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[3];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifdef VSUSETEX2
#ifndef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[2];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSETEX1
#ifndef VSUSETEX2
#ifndef VSUSETEX3
#ifndef VSUSETEX4
varying highp vec2 v_texCoords[1];		//scaled and passed through
#endif
#endif
#endif
#endif
#ifdef VSUSEVCOLOUR
varying highp vec4 v_blend;
#endif

#ifndef USEPHONG
#ifdef USEREFLECTION	
varying highp vec3 v_reflecVec;
#endif
#ifdef USESPECULAR
varying highp vec3 v_colourSpec;
#endif
#ifdef USEDIFFUSELIGHTING
varying highp vec3 v_colour;
#endif
#endif



uniform mat4 MeshX[12];


#define LIGHTMATERIAL_DIFFUSE		0
#define LIGHTMATERIAL_AMBIENT		1
#define LIGHTMATERIAL_SPECULAR		2
#define LIGHTMATERIAL_EMISSIVE		3
#define LIGHTMATERIAL_SPECULARPOWER	4
#define LIGHTMATERIAL_REFLECMULT	4
#define LIGHTMATERIAL_SHADOWMULT	4
#define LIGHTMATERIAL_NORMALHEIGHT	4
#define LIGHTMATERIAL_MULCOL		5

#define LIGHTMATERIAL_TOTALSIZE     6		

#define lightMaterial_specular			LightMaterial[LIGHTMATERIAL_SPECULAR]
#define lightMaterial_ambient			LightMaterial[LIGHTMATERIAL_AMBIENT]
#define lightMaterial_diffuse			LightMaterial[LIGHTMATERIAL_DIFFUSE]
#define lightMaterial_emissive			LightMaterial[LIGHTMATERIAL_EMISSIVE]
#define lightMaterial_specularpower		LightMaterial[LIGHTMATERIAL_SPECULARPOWER][0]
#define lightMaterial_reflecMult		LightMaterial[LIGHTMATERIAL_REFLECMULT][1]
#define lightMaterial_shadowMult		LightMaterial[LIGHTMATERIAL_SHADOWMULT][2]
#define lightMaterial_normalHeight		LightMaterial[LIGHTMATERIAL_NORMALHEIGHT][3]
#define lightMaterial_mulcol			LightMaterial[LIGHTMATERIAL_MULCOL]

uniform vec4 LightMaterial[LIGHTMATERIAL_TOTALSIZE];

#define LIGHTS_AMBIENT		0
#define LIGHTS_SIZE			1

#define LIGHT_DIFFUSE		0
#define LIGHT_SPECULAR		1
#define LIGHT_POSITION		2
#define LIGHT_DIRECTION		3
#define LIGHT_RANGE			4
#define LIGHT_ATTENUATION0	4
#define LIGHT_ATTENUATION1	4
#define LIGHT_ATTENUATION2	4
#define LIGHT_SIZE			5


#define LIGHTS_TOTALSIZE (LIGHTS_SIZE+NUMLIGHTSTOUSE*LIGHT_SIZE)

//#define lights_numLights		Lights[LIGHTS_NUMLIGHTS][0]

#define lights_ambient			Lights[LIGHTS_AMBIENT]

#define light_diffuse(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_DIFFUSE]
#define light_specular(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_SPECULAR]
#define light_position(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_POSITION]
#define light_direction(_n)		Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_DIRECTION]
#define light_range(_n)			Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_RANGE][0]
#define light_attenuation0(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION0][1]
#define light_attenuation1(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION1][2]
#define light_attenuation2(_n)	Lights[LIGHTS_SIZE + LIGHT_SIZE*_n + LIGHT_ATTENUATION2][3]

uniform vec4 Lights[LIGHTS_TOTALSIZE];

//#define SHADER_LIGHT_DIRECTIONAL	0.0
//#define SHADER_LIGHT_POINT			1.0

// constants
uniform float	c_fTime;		
uniform float	c_windMult;
uniform float	c_shakeMult;
uniform float	c_windX;
uniform float	c_windY;

uniform	float	reflecRotSin;
uniform float	reflecRotCos;

uniform float	c_uvDeltaU1;
uniform float	c_uvDeltaV1;
uniform float	c_uvDeltaU2;
uniform float	c_uvDeltaV2;
uniform float	c_uvMultiply;

uniform vec4	c_depthColour;

uniform	float c_SnowMask1Scaling;			//only if useSnow
uniform	float c_SnowMask2Scaling;
uniform	float c_RefMaskScaling;
uniform	float c_SnowTexScaling;

uniform float	c_waveFrequency;
uniform float	c_waveSpeed;
uniform float	c_waveIntensity;

uniform float	c_ovSize0;					
uniform float	c_ovSize1;					
uniform float	c_ovSize2;					
uniform float	c_ovSize3;					

uniform float	c_ovPosX0;					
uniform float	c_ovPosX1;					
uniform float	c_ovPosX2;					
uniform float	c_ovPosX3;					

uniform float	c_ovPosY0;					
uniform float	c_ovPosY1;					
uniform float	c_ovPosY2;					
uniform float	c_ovPosY3;					


uniform float	c_uThickness;
uniform float	c_uMaterialFresnel;
uniform float	c_uReflectionFresnel;
uniform float	c_uUFrames;

uniform float	c_ScrollSpeed;
uniform float	c_FresnelPower;
uniform float	c_FresnelBias;
uniform float	c_uUFrameTime;


//Mirror gShader values
uniform mat4 modelViewProjectionMatrix;			//USED in Vshader
uniform mat4 modelMatrix;						//USED in VSHader
uniform mat4 viewProjectionMatrix;				//USED in vShader

uniform vec4 camPos;
uniform vec4 camZDir;


uniform sampler2D s_texture1;
uniform sampler2D s_texture2;
uniform sampler2D s_texture3;
uniform sampler2D s_texture4;
uniform sampler2D s_texture5;
uniform sampler2D s_texture6;
uniform sampler2D s_texture7;
uniform samplerCube s_texture8;


vec4 saturate(vec4 v)
{
	v.x=clamp(v.x,0.0,1.0);
	v.y=clamp(v.y,0.0,1.0);
	v.z=clamp(v.z,0.0,1.0);
	v.w=clamp(v.w,0.0,1.0);
	return v;
}

float frac(float f)
{
	float r=f-floor(f);
	return r;
}

vec3 saturate(vec3 v)
{
	v.x=clamp(v.x,0.0,1.0);
	v.y=clamp(v.y,0.0,1.0);
	v.z=clamp(v.z,0.0,1.0);
	return v;
}

float saturate(float x)
{
	x=clamp(x,0.0,1.0);
	return x;
}

//-----------------------------------------------------
#ifdef LIGHTINGORREFLEC

struct Uber_cLightAndReflec
{
#ifdef USEDIFFUSELIGHTING
	 vec3	colour;
#endif
#ifdef USESPECULAR
	 vec3	colourSpec;
#endif	
#ifdef USEREFLECTION
	 vec3	reflecVec;
#endif
};

Uber_cLightAndReflec gLightAndReflec;
void Uber_DoLightsAndReflec(
						 vec3 pos_ms,									//pos in model space
						 vec3 nrm_ms)									//nrm in model space
{
	Uber_cLightAndReflec C;												//output
	
	vec3 pos_ws = ( modelMatrix * vec4(pos_ms,1.0)).xyz;				//pos in world space
	vec3 nrm_ws = ( modelMatrix * vec4(nrm_ms,0.0)).xyz;				//nrm in world space

#ifdef USEDIFFUSELIGHTING
	C.colour.rgb=lights_ambient.rgb;									//ambient
#endif
#ifdef USESPECULAR
	C.colourSpec.rgb=vec3(0.0);
#endif
#ifdef USEREFLECTION
	C.reflecVec.rgb=vec3(0.0);
#endif	

	nrm_ws=normalize(nrm_ws);
	
	vec3 ptoc_wsn = normalize(pos_ws.xyz-camPos.xyz);					//note used later in specular	

#ifdef USEREFLECTION
	C.reflecVec.rgb = normalize( reflect ( ptoc_wsn, nrm_ws ) );				//vector for cubemap lookup
	
#ifdef USEROTATEREFLECTION		//new
	float x2=C.reflecVec.x*reflecRotCos+C.reflecVec.y*reflecRotSin;
	float y2=C.reflecVec.y*reflecRotCos-C.reflecVec.x*reflecRotSin;
	C.reflecVec.x=x2;
	C.reflecVec.y=y2;
#endif

#ifdef USEROTREFLEC
	float q=C.reflecVec.y;
	C.reflecVec.y=C.reflecVec.z;
	C.reflecVec.z=-q;
#endif
#endif

	float NdotL;
	vec3 hv_wsn;
	float d;
	float specpow;
	vec3 L_wsn;
	vec3 r;
	vec3 ltop_ws;
	vec3 ltop_wsn;
	float fAtten;
	float LD;
	

//<#INSERTLIGHTS#>
	

#ifdef USEDIFFUSELIGHTING
	C.colour.rgb*=lightMaterial_diffuse.rgb;															//do ONCE now not in light accumulation code
#endif
#ifdef USESPECULAR
	C.colourSpec.rgb*=lightMaterial_specular.rgb;
#endif	

	gLightAndReflec=C;
	//return(C);
}

//



#endif		//if LIGHTINGORREFLEC
//-----------------------------------------------------

	
void main()
{

#ifndef VSUSEBONES
	vec4 pos=vec4(a_position.xyz,1.0);
#ifdef VSUSENORMAL
	vec4 norm;
	norm.xyz=a_normal.xyz;
	norm.w=0.0;
#endif
#endif

#ifdef VSUSEBONES
	float weight;
	highp vec4 t;
	vec3 norm;
	int i;
	highp vec4 pos;
	highp vec4 p;
	
	p=a_position;
	pos=vec4(0.0,0.0,0.0,1.0);
	norm=vec3(0.0,0.0,0.0);
	
	//<#UNROLL#>
	for (int b=0;b<4;b++)  //EMS-Firefox has to have 'int b' decleration here
	{
		i=int(a_boneindices[b]);
		weight=a_boneweights[b];
#ifndef PLATFORM_EMS
		if (weight!=0.0)  //This wasn't working on Windows 7 Chrome browser
#endif
		{
			t=MeshX[i]*p;
			pos.xyz+=t.xyz*weight;
#ifdef VSUSENORMAL			
			t.xyz=mat3(MeshX[i][0].xyz,MeshX[i][1].xyz,MeshX[i][2].xyz)*a_normal.xyz;
			norm+=t.xyz*weight;
#endif
		}
	}
#endif	

#ifdef USESNOW
	pos.y+=saturate((a_vcolour.b-0.25)*0.6);
#endif
	
#ifdef USESPECIAL_AURORA
	pos.xyz += (a_vcolour.b-0.5)*norm.xyz * c_waveIntensity * sin((c_fTime * 6.284  * c_waveFrequency) + (a_vcolour.g * 6.284));
#endif

#ifdef VSUSEPOSITION

#ifndef VSUSEWIND

	gl_Position=modelViewProjectionMatrix*pos;
	v_position=modelViewProjectionMatrix*pos;
	//float4 cam=mul(pos,ModelViewProjMat);			//output position = camera space +-1

#endif

#ifdef VSUSEWIND

#ifdef USEGRASSSHADER 

	vec4 wsp=modelMatrix *pos;						// to world space
	vec3 u2 = wsp.xyz;

	float windStr = abs(c_windX) + abs(c_windY);
	float offset = dot(normalize(vec2(c_windX, c_windY)), vec2(u2.x, u2.y));
	float offsetWave = sin((c_fTime * windStr * 0.15) + (a_vcolour.r * 2.0) - offset);

	//float waveClamp = clamp((offsetWave + 0.5) * windStr * 0.25, 0, 1);
	float waveClamp = (offsetWave + 1.0) * 0.5;
	float wave = (offsetWave + 1.0) * 0.5;
	float shakeWave = sin((c_fTime * 0.1 * windStr * 15.0) + (a_vcolour.r * 3.14159265 * 2.0)) * 0.01;
	float shakeX = shakeWave * 0.2 * ((0.25 * windStr) + (0.75 * abs(c_windX))) * (0.5 + (wave * 0.5)) * (0.5 + (a_vcolour.r * 0.5));
	float shakeY = shakeWave * 0.2 * ((0.25 * windStr) + (0.75 * abs(c_windY))) * (0.5 + (wave * 0.5)) * (0.5 + (frac(a_vcolour.r + 0.25) * 0.5));
	float bendX = (waveClamp * 0.04 * c_windX) * c_windMult * a_vcolour.g;
	float bendY = (waveClamp * 0.04 * c_windY) * c_windMult * a_vcolour.g;

	u2.x += bendX;
	u2.y += bendY;
	u2.z -= (abs(bendX) + abs(bendY)) * 0.25;
	u2.x += shakeX * a_vcolour.g * c_shakeMult;
	u2.y += shakeY * a_vcolour.g * c_shakeMult;
	u2.z -= (abs(shakeX) + abs(shakeY)) * 0.25 * a_vcolour.g * c_shakeMult;

	wsp.xyz = u2;
	vec4 cam=viewProjectionMatrix*wsp;		

#endif

#ifndef USEGRASSSHADER 

	vec4 wsp=modelMatrix *pos;					//mul(pos,ModelMat);		// to world space
	vec3 u2 = wsp.xyz;
	
	float windStr = abs(c_windX) + abs(c_windY);
	float offset = dot(normalize(vec2(c_windX, c_windY)), vec2(u2.x, u2.y));
	float treeWindX = ((sin((c_fTime * 2.0) - (offset * 0.05)) * 0.5) + 0.5) * a_vcolour.g * c_windX;
	float treeWindZ = ((sin((c_fTime * 2.0) - (offset * 0.05)) * 0.5) + 0.5) * a_vcolour.g * c_windY;

	float branchWind = sin((c_fTime * (3.0 + (a_vcolour.b * 2.0))) + (a_vcolour.b * 2.0 * 3.14159265)) * (0.25 + (a_vcolour.g * 0.75)) * a_vcolour.r;
	u2.x += treeWindX * 4.0 * c_windMult;
	u2.y += treeWindZ * 4.0 * c_windMult;
	u2.z -= (abs(treeWindX) + abs(treeWindZ)) * 0.5 * c_windMult;
	u2.x += branchWind * c_windX * 1.0 * c_windMult;
	u2.y += branchWind * c_windY * 1.0 * c_windMult;
	u2.z -= branchWind * (abs(c_windX) + abs(c_windY)) * 0.25 * c_windMult;
	u2.xyz += sin((c_fTime * (1.0 + windStr ) * (0.25 + (a_vcolour.b * 0.75))) + (wsp.xyz * 5.0)) * (0.25 + (a_vcolour.g * 0.75)) * a_vcolour.r * 0.1 * c_shakeMult * vec3(windStr * 0.5 + (c_windX * 0.5), windStr * 0.5 + (c_windY * 0.5), windStr * 0.5);
	wsp.xyz = u2;
	vec4 cam=viewProjectionMatrix*wsp;			//mul(wsp,ViewProjMat);	

#endif

	gl_Position=cam;
	v_position=cam;

#endif






#endif
#ifdef VSUSEPOSITIONSMAP
	v_position_lig=modelViewProjShadowMatrix*pos;		//pos is interpolated pixel pos across mesh triangle
														//output is where this pixel would appear on distance texture
#endif
#ifdef VSUSECOLOUR
	v_vertcol=vec4(a_colour.b,a_colour.g,a_colour.r,a_colour.a);		//This line didn't work on iPhone 4's so changed to floats
#endif
		
#ifdef USEPHONG
	v_normal.xyz   = norm.xyz;		//a_normal.xyz;
#endif
#ifdef USEGREENFRESNEL		
	v_normalrot= normalize((modelMatrix * vec4(norm.xyz,0)).xyz);		//this only needs to be mul 3x3 SHAUNEEK
#endif
#ifdef PASSPOSITIONTHRO
	v_positionthro.xyz = pos.xyz;		//a_position;
#endif
#ifdef WORLDPOSITION
	vec3 wp=( modelMatrix * vec4(pos.xyz,1.0)).xyz;		
	v_worldposition.xyz = wp;
#endif

#ifdef NEWOVERLAY
#ifdef USEOVERLAY0
	vec2 ov0;
	ov0.x=(wp.x-c_ovPosX0)/c_ovSize0;
	ov0.y=(wp.y-c_ovPosY0)/c_ovSize0;
	v_overlay0=ov0;		
#endif
#ifdef USEOVERLAY1
	vec2 ov1;
	ov1.x=(wp.x-c_ovPosX1)/c_ovSize1;
	ov1.y=(wp.y-c_ovPosY1)/c_ovSize1;
	v_overlay1=ov1;		
#endif
#ifdef USEOVERLAY2
	vec2 ov2;
	ov2.x=(wp.x-c_ovPosX2)/c_ovSize2;
	ov2.y=(wp.y-c_ovPosY2)/c_ovSize2;
	v_overlay2=ov2;		
#endif
#ifdef USEOVERLAY3
	vec2 ov3;
	ov3.x=(wp.x-c_ovPosX3)/c_ovSize3;
	ov3.y=(wp.y-c_ovPosY3)/c_ovSize3;
	v_overlay3=ov3;		
#endif
#endif

#ifdef VSUSETANGENTS
	v_tangent.xyz  = a_tangent.xyz;
	v_binormal.xyz = a_binormal.xyz;
#endif

#ifndef USEPHONG			
	
#ifdef FASTSHADER
	norm.xyz=vec3(0.0,0.0,1.0);			//fix for black horizon
#endif

//not done here if phong
#ifdef LIGHTINGORREFLEC
	Uber_DoLightsAndReflec(pos.xyz, norm.xyz);				//work out lights per vertex
	Uber_cLightAndReflec C=gLightAndReflec;
#endif
#ifdef USEREFLECTION
	v_reflecVec.xyz = C.reflecVec.xyz;		
#endif
#ifdef USEDIFFUSELIGHTING
	v_colour.rgb=C.colour.rgb;
#endif
#ifdef USESPECULAR
	v_colourSpec.rgb=C.colourSpec.rgb;
#endif
#endif



#ifdef VSUSETEX1
	
#ifdef USESCROLLU0
	//vec2 tc0=(a_texCoord12.xy+c_uvPosition[0].xy)*c_uvPosition[0].zw;			
	vec2 tc0=a_texCoord12.xy;			
	float db=floor(c_fTime/c_uUFrameTime);
	float uoff=db/c_uUFrames;
	float uoff8=floor(uoff/8.0);	// limit so uvs dont get too big
	uoff-=uoff8*8.0;
	tc0.x+=uoff;		
	v_texCoords[0]=tc0;
#endif
#ifndef USESCROLLU0
	//v_texCoords[0]=(a_texCoord12.xy+c_uvPosition[0].xy)*c_uvPosition[0].zw;		
	v_texCoords[0]=a_texCoord12.xy;		
#endif




#endif
#ifdef VSUSETEX2
#ifdef VSUSETEX1
	v_texCoords[1] = a_texCoord12.zw;	
#endif
#ifndef VSUSETEX1
	v_texCoords[1] = a_texCoord12.xy;	
#endif
#endif

#ifdef VSUSETEX3
	v_texCoords[2] = a_texCoord34.xy;	
#endif
#ifdef VSUSETEX4
#ifdef VSUSETEX3
	v_texCoords[3] = a_texCoord34.zw;	
#endif
#ifndef VSUSETEX3
	v_texCoords[3] = a_texCoord34.xy;	
#endif
#endif


#ifdef VSUSEVCOLOUR
	v_blend = a_vcolour;
#endif
}


	
